<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:per="http://seaf.sf.net/seaf-persistence"
	xmlns:svc="http://seaf.sf.net/seaf-service"
	version="2.0">
<import href="generator/seaf-persistence/functions/SeafPersistenceBusinessFunctions.xsl" />
<import href="functions/SeafServiceBusinessFunctions.xsl" />
<output method="text" />

<param name="persistence-merged-file-name" />
<variable name="merged-persistence-file" select="document($persistence-merged-file-name)" />

<variable name="persistence-enum-defs" select="$merged-persistence-file//per:persistence//per:enum-def" />

<template match="//svc:service-layer//svc:enum-def">
	<variable name="full-type" select="svc:enum-full-type(.)" />
	<variable name="class" select="seaf:type-class($full-type)" />
	<variable name="dir" select="seaf:type-dir($full-type)" />
	<variable name="package" select="seaf:type-package($full-type)" />
	<variable name="persistence-enum-def" 
		select="svc:persistence-enum-ref(@entity,$merged-persistence-file)" />

<result-document href="{$dir}/{$class}.java">

<text />/**
 * GENERATED BY Seaf Service Generator. DO NOT EDIT.
 */
package <value-of select="$package" />;

/**
 * <value-of select="$class" /> service enumeration.<text />
	<if test="$persistence-enum-def/per:description">
 * &lt;p>
 * <value-of select="$persistence-enum-def/per:description" />
	</if>
 */
public enum <value-of select="$class" /> {<text />

	<for-each select="$persistence-enum-def/per:enum-value">
	<text>
</text>
		<if test="@description">
	/**
	 * <value-of select="@description" />
	 */<text />
		</if>
		<text>
	</text>
		<value-of select="@code" />
		<if test="not(position()=last())">,</if>
	</for-each>

}
<text />

</result-document>
</template>

</stylesheet>
