<?xml version="1.0" encoding="UTF-8"?>
<stylesheet
	xmlns="http://www.w3.org/1999/XSL/Transform"
	xmlns:seaf="http://seaf.sf.net/seaf"
	xmlns:svc="http://seaf.sf.net/seaf-service"
	version="2.0">
<import href="functions/SeafServiceTemplates.xsl" />
<output method="text" />

<param name="service-merged-file-name" />
<variable name="merged-service-file" select="document($service-merged-file-name)" />
<variable name="objects" select="$merged-service-file//svc:service-layer//svc:object" />

<template match="//svc:service-layer/svc:service">
	<variable name="full-type" select="svc:service-interface-full-type(.)" />
	<variable name="class" select="seaf:type-class($full-type)" />
	<variable name="dir" select="seaf:type-dir($full-type)" />
	<variable name="package" select="seaf:type-package($full-type)" />

<result-document href="{$dir}/{$class}.java">

<text />/**
 * GENERATED BY Seaf Persistence Generator. DO NOT EDIT.
 */
package <value-of select="$package" />;

/**
 * Service interface <value-of select="$class" />.
 */
@javax.jws.WebService
public interface <value-of select="$class" /> {<text />

<for-each select="svc:controller">
	<variable name="controller-entity" select="@entity" />

	// Operations of the controller of entity <value-of select="$controller-entity" />
	<for-each select="svc:operation">
		<variable name="request">
			<choose>
			<when test="svc:request-void" />
			<otherwise>
				<variable name="arg-name" 
					select="seaf:first-lower(svc:request-object/@entity)" />
			@javax.validation.constraints.NotNull
			@javax.jws.WebParam(name = "<value-of select="$arg-name" />")
			<text />
				<variable name="request-object-full-type" 
					select="svc:ref-service-object-full-type(svc:request-object,$objects)" />
				<value-of select="$request-object-full-type" />
				<text> </text>
				<value-of select="$arg-name" />
			</otherwise>
			</choose>
		</variable>
		<variable name="response">
			<choose>
			<when test="svc:response-void">void</when>
			<otherwise>
				<variable name="response-object-full-type" 
					select="svc:ref-service-object-full-type(
					svc:response-object|svc:response-sequence,$objects)" />
				<value-of select="$response-object-full-type" />
				<choose>
				<when test="svc:response-sequence[@paged='true']">PagedResult</when>
				<when test="svc:response-sequence">[]</when>
				</choose>
			</otherwise>
			</choose>
		</variable>
		<value-of select="svc:method-signature(.,@name,$request,$response,true())" />
	</for-each>
</for-each>

<text />

}
<text />

</result-document>
</template>

</stylesheet>
